"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const bf_types_1 = require("bf-types");
const common_1 = require("../common");
const system_1 = require("../system");
let userDoc = null;
let userDocs = null;
function getUser() {
    return __awaiter(this, void 0, void 0, function* () {
        return system_1.default.nexus.getUser();
    });
}
function getUserDoc() {
    return __awaiter(this, void 0, void 0, function* () {
        if (userDoc) {
            return userDoc;
        }
        const api = system_1.default.getLibModule(system_1.LibModule.API);
        const userId = system_1.default.nexus.getUser().sub;
        const user = yield api.get(`core/user/entity/${userId}`);
        if (!user) {
            throw new Error('Failed to retrieve the document for the authenticated user.');
        }
        userDoc = user;
        return user;
    });
}
function getUserDocs() {
    return __awaiter(this, void 0, void 0, function* () {
        if (userDocs) {
            return userDocs;
        }
        const api = system_1.default.getLibModule(system_1.LibModule.API);
        const users = yield api.get('users');
        if (!users || !Array.isArray(users)) {
            return [];
        }
        userDocs = users;
        return users;
    });
}
function getOrganization() {
    return __awaiter(this, void 0, void 0, function* () {
        return common_1.moduleLink(bf_types_1.CORE_MODULES.ORGANIZATION, system_1.default.nexus.getUser().organization[0]);
    });
}
function logOut() {
    system_1.default.nexus.logOut();
}
const auth = {
    getUser,
    getUserDoc,
    getUserDocs,
    getOrganization,
    logOut,
};
exports.default = system_1.default.sealModule(Object.freeze(auth));
